﻿using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Drawing;
using System.Linq;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;

namespace Demo01
{
	public sealed partial class HelloWorldWorkflow: SequentialWorkflowActivity
	{
        ApplicationException thrownException = new ApplicationException("My personal exception");

        public ApplicationException ThrownSampleException
        {
            get { return thrownException; }
            set { thrownException = value; }
        }

		public HelloWorldWorkflow()
		{
			InitializeComponent();
		}

        public static DependencyProperty codeActivity1_ExecuteCode1Event = DependencyProperty.Register("codeActivity1_ExecuteCode1", typeof(System.EventHandler), typeof(Demo01.HelloWorldWorkflow));

        [DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)]
        [BrowsableAttribute(true)]
        [CategoryAttribute("Handlers")]
        public event EventHandler codeActivity1_ExecuteCode1
        {
            add
            {
                base.AddHandler(codeActivity1_ExecuteCode1Event, value);
            }
            remove
            {
                base.RemoveHandler(codeActivity1_ExecuteCode1Event, value);
            }
        }

        private void Workflow1_Initialized(object sender, EventArgs e)
        {

        }

        private void Workflow1_Completed(object sender, EventArgs e)
        {

        }

        private void codeActivity1_ExecuteCode(object sender, EventArgs e)
        {
            Console.WriteLine("Hello World Again!");
            throw new ApplicationException("everything is going wrong");
        }

        private void codeActivity2_ExecuteCode(object sender, EventArgs e)
        {
            Console.WriteLine("Gotcha the Exception in the Activity!");
        }

        private void codeActivity3_ExecuteCode(object sender, EventArgs e)
        {
            Console.WriteLine("Entering the Global Exception Handler");
            Console.WriteLine("Exception was " + this.ThrownSampleException.Message);
        }
	}

}
